using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.DataVisualization.Charting;
using NSSetCol123;


namespace TestChart2D
{
    public partial class Form1CFX : Form
    {

        FormSColFX frmCol;
        public Form1CFX()
        {
            InitializeComponent();
            frmCol = new FormSColFX(chart1);
            coldefault = new Color[8];
            chart1.Series[0].Color = Color.Black;
            coldefault[0] = Color.Black;
            coldefault[1] = Color.Blue;
            coldefault[2] = Color.Red;
            coldefault[3] = Color.Green;
            coldefault[4] = Color.Brown;
            coldefault[5] = Color.Violet;
            coldefault[6] = Color.Orange;
            coldefault[7] = Color.PaleGreen;
        }

        Color[] coldefault;
        int Perioden = 2;

        private void button1Test_Click(object sender, EventArgs e)
        {

            chart1.Visible = true; 
              int i, serie = 1;
              if (chart1.Series.Count==0)
                  chart1.Series.Add("Kurve " + serie.ToString());
            int nb = (int)numericUpDown1.Value;
            double x;
            chart1.Series[0].ChartType = SeriesChartType.Line;
            for (i = 0; i < nb; i++)
            {
                x = i * 2 * Math.PI * (Perioden + serie) / nb;
                chart1.Series[0].Points.AddXY(x, 1* Math.Sin(x));
            }
        }

        short serie = 1;
        private void buttonMulti_Click(object sender, EventArgs e)
        {
            chart1.Visible = true;
            int i, nb = (int)numericUpDown1.Value; ;
            double x,y;
            if (serie >chart1.Series.Count)
                chart1.Series.Add("Kurve " + serie.ToString());
            if (chart1.Series.Count < 9)
                chart1.Series[serie - 1].Color = coldefault[serie - 1];
            chart1.Series[serie-1].ChartType = SeriesChartType.Line;
            for (i = 0; i < nb; i++)
            {
                x = i * 2 * Math.PI  / nb;
                y = Math.Sin(x * (Perioden + serie));
                chart1.Series[serie - 1].Points.AddXY(x, y);
            }
            serie++;
            nudClearCurve.Value = serie-1;

        }

        private void buttontoggleTB_Click(object sender, EventArgs e)
        {
            if (chart1.ChartAreas[0].AxisX.MajorGrid.Enabled)
            {
                chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = false;
                chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = false;
            }
            else
            {
                chart1.ChartAreas[0].AxisX.MajorGrid.Enabled = true;
                chart1.ChartAreas[0].AxisY.MajorGrid.Enabled = true;
            }
        }

 

        private void buttonScale_Click(object sender, EventArgs e)
        {
            chart1.ChartAreas[0].AxisX.Interval = 1;
            chart1.ChartAreas[0].AxisX.Minimum = 0;
            chart1.ChartAreas[0].AxisX.Maximum = 6;
        }

        private void buttonLegend_Click(object sender, EventArgs e)
        {
            //chart2D1.clearLast();
            if (chart1.Series.Count > 1)
            {
                chart1.Series.Remove(chart1.Series[(int)nudClearCurve.Value - 1]);
                serie--;
                nudClearCurve.Value = serie - 1;
            }
            else
            {
                chart1.Series.Clear();
            }
                
        }

        private void buttonTitle_Click(object sender, EventArgs e)
        {
            chart1.Titles.Clear();
            chart1.Titles.Add("");
            chart1.Titles.Add("");
            chart1.Titles.Add("");
            chart1.Titles[0].Docking = Docking.Top;
            chart1.Titles[1].Docking = Docking.Bottom;
            chart1.Titles[0].Text = "Top Header Title";
            chart1.Titles[1].Text = "Bottom Title text";
            chart1.Titles[2].Docking = Docking.Left;
            chart1.Titles[2].Text = "Left Title";

            chart1.Series[0].LegendText = "Kurve 1";
            chart1.Series[0].Color=Color.Red;

        }

         int itemp = 0;

        private void timer1_Tick(object sender, EventArgs e)
        {
            //chart2D1.realTimeChart((serie-1), itemp, Math.Sin(itemp / 16.0 * serie));
            //itemp++;
            //if (itemp > 100)
            //{
            //    itemp = 0;
            //    serie++;
            //}
            //if (serie > 5)
            //{
            //    serie = 1;
            //    chart2D1.clearAll();
            //}

        }

        private void buttonTogMinGrid_Click(object sender, EventArgs e)
        {
            //chart1.ChartAreas[0].BorderColor = Color.Green;
            if (chart1.ChartAreas[0].AxisX.MinorGrid.Enabled)
            {
                chart1.ChartAreas[0].AxisX.MinorGrid.Enabled = false;
                chart1.ChartAreas[0].AxisY.MinorGrid.Enabled = false;
            }
            else
            {
                chart1.ChartAreas[0].AxisX.MinorGrid.Enabled = true;
                chart1.ChartAreas[0].AxisY.MinorGrid.Enabled = true;
            }

        }

        private void buttonColor_Click(object sender, EventArgs e)
        {
            frmCol.ShowDialog();
        }

        private void buttonBode_Click(object sender, EventArgs e)
        {
            chart1.Series.Clear();
            serie = 1;
            chart1.Series.Add("Bode Plot Mag");
            chart1.Series.Add("Phase");
            chart1.Series[0].ChartType = SeriesChartType.Line;
            chart1.Series[1].ChartType = SeriesChartType.Line;
            chart1.Series[1].YAxisType = AxisType.Secondary;
            // Achse fr Frequenz
            chart1.ChartAreas[0].AxisX.IsLogarithmic = true;
            chart1.ChartAreas[0].AxisX.MinorGrid.LineColor = Color.Gray;
            chart1.ChartAreas[0].AxisX.MinorGrid.Interval = 1;

            // Achse fr Betrag
            chart1.ChartAreas[0].AxisY.Title = "Betrag";
            chart1.ChartAreas[0].AxisY.Enabled = AxisEnabled.True;   // Enable the second Y-axis.
            chart1.ChartAreas[0].AxisY.Minimum = -90;
            chart1.ChartAreas[0].AxisY.Maximum = 0;
            chart1.ChartAreas[0].AxisY.Interval = 10;
            chart1.ChartAreas[0].AxisY.MajorGrid.Interval = 10;
            chart1.ChartAreas[0].AxisY.MajorGrid.LineColor = Color.Blue;
            chart1.ChartAreas[0].AxisY.MinorGrid.LineColor = Color.LightBlue;

            
            // Achse fr Phase
            chart1.ChartAreas[0].AxisY2.Title = "Grad";
            chart1.ChartAreas[0].AxisY2.Enabled = AxisEnabled.True;   // Enable the second Y-axis.
            chart1.ChartAreas[0].AxisY2.Minimum = -90;
            chart1.ChartAreas[0].AxisY2.Maximum = 0;
            chart1.ChartAreas[0].AxisY2.Interval = 10;
            chart1.ChartAreas[0].AxisY2.MajorGrid.Interval = 10;
            chart1.ChartAreas[0].AxisY2.MajorGrid.LineColor = Color.Orange;
            chart1.ChartAreas[0].AxisY2.MinorGrid.LineColor = Color.LemonChiffon;


            int nb = (int)numericUpDown1.Value;
            double xstart=0.1, dek=4;
            double dx=Math.Pow(10,(dek/nb));
            double x=xstart,y,z;
            for (int i = 0; i < nb; i++)
            {
              
                y = 1 / Math.Sqrt(1 + x * x);
                y = 20 * Math.Log10(y);
                z = -Math.Atan2(x,1)*180/Math.PI;
                chart1.Series[0].Points.AddXY(x, y);
                chart1.Series[1].Points.AddXY(x, z); 
                x = x*dx;
            }
            //chart1.ChartAreas[0].AxisX.Interval = 1;
            chart1.ChartAreas[0].AxisX.Minimum = 0.1;
            chart1.ChartAreas[0].AxisX.Maximum = 1000;
            serie = 3;

        }
    }
}