﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net.Mail;
using System.Net.Sockets;
using System.IO;
using System.Collections;

namespace Email
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            SettingsLoad();
            //Create directories for different usage
            if (System .IO .Directory .Exists (EditFNroot .Text + "TempAttach"))
                Directory.Delete(EditFNroot.Text + "TempAttach", true);//delete the temporery folder
            if (!System.IO.Directory.Exists(EditFNroot.Text + EditMailbox.Text))
                System.IO.Directory.CreateDirectory(EditFNroot.Text + EditMailbox.Text);
            if (!System.IO.Directory.Exists(EditFNroot.Text + EditMailbox.Text + "\\Inbox"))
                System.IO.Directory.CreateDirectory(EditFNroot.Text + EditMailbox.Text + "\\Inbox");
            fileListBoxEmailRecv.Path = EditFNroot.Text + EditMailbox.Text + "\\Inbox";
            if (!System.IO.Directory.Exists(EditFNroot.Text + EditMailbox.Text + "\\Address Group"))
                System.IO.Directory.CreateDirectory(EditFNroot.Text + EditMailbox.Text + "\\Address Group");
            if (!System.IO.Directory.Exists(EditFNroot.Text + EditAttach.Text))
                System.IO.Directory.CreateDirectory(EditFNroot.Text + EditAttach.Text);
            if (!System.IO.Directory.Exists(EditFNroot.Text + "TempAttach"))
                System.IO.Directory.CreateDirectory(EditFNroot.Text + "\\TempAttach");
            if (!System.IO.File.Exists(EditFNroot.Text + "MailAdressen.ini"))
                System.IO.File.Create(EditFNroot.Text + "MailAdressen.ini");
            else
                LoadFromFile(EditFNroot.Text + "MailAdressen.ini");
            
        }


        public static Form1 currentForm;
        
        public string Copylist = "Copy-list", Warning = "Warning", ErrorMess = "Error message:", Fail = "Fail";
        string TxtTo = "--- To:", TxtCC = "--- CC:", TxtBCC = "--- BCC:", TxtSender = "--- Sender:", TxtFrom = "--- From:", TxtEnd = "--- End",
           TxtBody = "--- Text:", TxtBodyEnd = "--- End Text";
        public string cannotempty = "The name cannot be empty";

        int checkprintEmail;
        bool ReceiveAddr = true, CcAddr = false, BCCAddr = false;
        //distinguish to whom the list should be added  
        string strSubject;//store mail subject temporarily
        string mailinfo;//store the connection infomation  

//*******************************************************************************
//--------------------                                  -------------------------
//--------------------       Email Send part            -------------------------
//--------------------                                  -------------------------        
//*******************************************************************************

/// <summary>
/// Email send
/// </summary>
/// <param name="sender"></param>
/// <param name="e"></param>
        private void btnSendEmail_Click(object sender, EventArgs e)
        {
            try
            {
                if (comboBoxReceiverAddr.Text != "")
                {
                    MailMessage Email = new MailMessage();

                    MailAddress Sender = new MailAddress(textBoxFrom.Text);
                    Email.From = Sender;

                    Email.To.Add(comboBoxReceiverAddr.Text);
                    if (comboBoxReceiverAddr.Items.Count > 0)
                    {//more than one recipient
                        for (int i = 0; i < comboBoxReceiverAddr.Items.Count; i++)
                        {
                            Email.To.Add(comboBoxReceiverAddr.Items[i].ToString ());
                        }
                    }

                    Email.Subject = textBoxSubject.Text;

                    if (rBtnHtml.Checked)
                    {
                        Email.IsBodyHtml = true;
                        Email.Body = htmlEditor1.Text;
                    }

                    if (rBtnPlainTxt.Checked)
                    {
                        Email.Body = richTextBoxSend.Text;
                    }               

                    //send email with CC 
                    if (comboBoxCCAddr.Text !="")
                        Email.CC.Add(comboBoxCCAddr.Text);
                    if (comboBoxCCAddr.Items.Count > 0)
                    {//more than one CC
                        for (int i = 0; i < comboBoxCCAddr.Items.Count; i++)
                        {
                            Email.To.Add(comboBoxCCAddr.Items[i].ToString());
                        }
                    }
                    //send email with BCC
                    if (comboBoxBCCAddr.Text != "")
                        Email.Bcc.Add(comboBoxBCCAddr.Text);
                    if (comboBoxBCCAddr.Items.Count > 0)
                    {//more than one BCC
                        for (int i = 0; i < comboBoxBCCAddr.Items.Count; i++)
                        {
                            Email.To.Add(comboBoxBCCAddr.Items[i].ToString());
                        }
                    }

                    //email has attachment or not
                    if (listBoxAttachSend.Items.Count > 0)
                    {
                        for (int i = 0; i < listBoxAttachSend.Items.Count; i++)
                        {// add attachment to email
                            Attachment attach = new Attachment(listBoxAttachSend.Items[i].ToString());
                            Email.Attachments.Add(attach);
                        }
                    }

                    string ServerName = textBoxSMTPHost.Text;
                    string Port = textBoxPort.Text;
                    
                    SmtpClient MailClient = new SmtpClient(ServerName, int.Parse(Port));

                    string UserName = textBoxUser.Text;
                    string Password = textBoxPass.Text;

                    System.Net.NetworkCredential Credentials = new System.Net.NetworkCredential(UserName, Password);

                    MailClient.Credentials = Credentials;

                    MailClient.Send(Email);
                    MessageBox.Show("Email is sent successfully!");

                }
            }
            catch( Exception error)
            {
                MessageBox.Show(ErrorMess + error.Message, Fail, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnReceiver_Click(object sender, EventArgs e)
        {//edit receiver in address book
            listBoxCopyList.Items.Clear();
            if (comboBoxReceiverAddr.Text != "")
                listBoxCopyList.Items.Add(comboBoxReceiverAddr.Text);
            if (comboBoxReceiverAddr.Items.Count > 0)
            {
                for (int i = 0; i < comboBoxReceiverAddr.Items.Count; i++)
                {
                    listBoxCopyList.Items.Add(comboBoxReceiverAddr.Items[i]);
                }
            }

            ReceiveAddr = true;// copy-list should be copied to recipient
            CcAddr = false;
            BCCAddr = false;
            label19.Text = Copylist + TxtTo;
            tabCtrlEmail.SelectTab(tabPageAdd);
        }

        private void btnCC_Click(object sender, EventArgs e)
        {//edit Cc in address book
            listBoxCopyList.Items.Clear();
            if (comboBoxCCAddr.Text != "")
                listBoxCopyList.Items.Add(comboBoxCCAddr.Text);
            if (comboBoxCCAddr.Items.Count > 0)
            {
                for (int i = 0; i < comboBoxCCAddr.Items.Count; i++)
                {
                    listBoxCopyList.Items.Add(comboBoxCCAddr.Items[i]);
                }
            }
            CcAddr = true;// copy-list should be copied to CC
            ReceiveAddr = false;
            BCCAddr = false;
            label19.Text = Copylist + TxtCC;
            tabCtrlEmail.SelectTab(tabPageAdd);
        }

        private void btnBCC_Click(object sender, EventArgs e)
        {//edit BCC in address book
            listBoxCopyList.Items.Clear();
            if (comboBoxBCCAddr.Text != "")
                listBoxCopyList.Items.Add(comboBoxBCCAddr.Text);
            if (comboBoxBCCAddr.Items.Count > 0)
            {
                for (int i = 0; i < comboBoxBCCAddr.Items.Count; i++)
                {
                    listBoxCopyList.Items.Add(comboBoxBCCAddr.Items[i]);
                }
            }
            BCCAddr = true;// copy-list should be copied to BCC
            ReceiveAddr = false;
            CcAddr = false;
            label19.Text = Copylist + TxtBCC;
            tabCtrlEmail.SelectTab(tabPageAdd);
        }

        private void btnAddAttach_Click(object sender, EventArgs e)
        {// add attachment
            if (checkBoxAttachLimitation.Checked)
            {
                OpenFileDialog oFileDialog = new OpenFileDialog();
                if (oFileDialog.ShowDialog() == DialogResult.OK)
                    listBoxAttachSend.Items.Add(oFileDialog.FileName);
            }           
        }

        private void btnClosePreview_Click(object sender, EventArgs e)
        {// close the preview of attachment

            richTextBoxSend.Visible = false;
            pictureBoxSend.Visible = false;
            webBrowserSend.Visible = false;
            if (rBtnHtml.Checked)
                htmlEditor1.Visible = true;
            else if (rBtnPlainTxt.Checked)
            {
                richTextBoxSend.Dock = DockStyle.Fill;
                richTextBoxSend.Visible = true;
            }
        }

        private void btnDelAttach_Click(object sender, EventArgs e)
        {//remove the selected attachment
            listBoxAttachSend.Items.RemoveAt (listBoxAttachSend .SelectedIndex );
        }

        private void listBoxAttachSend_Click(object sender, EventArgs e)
        {// give a preview of selected attachment. Different format will be open in different controls.
            string fn, suff;
            if (listBoxAttachSend.Items.Count > 0)
            {
                fn = listBoxAttachSend.Items[listBoxAttachSend.SelectedIndex].ToString(); ;
                suff = Path.GetExtension(fn).ToLower();
                if ((suff == ".txt") || (suff == ".mtx") || (suff == ".rtf"))
                {//open with richtextbox control 
                    webBrowserSend.Visible = false;
                    webBrowserSend.Height = 1;
                    webBrowserSend.Width = 1;
                    htmlEditor1.Visible = false;
                    pictureBoxSend.Visible = false;
                    richTextBoxSend.Dock = DockStyle.Fill;
                    richTextBoxSend.Visible = true;
                    if (suff == ".rtf")
                        richTextBoxSend.LoadFile(fn, RichTextBoxStreamType.RichText);
                    else
                        richTextBoxSend.LoadFile(fn, RichTextBoxStreamType.PlainText);
                }
                if ((suff == ".jpg") || (suff == ".jpeg") || (suff == ".gif") || (suff == ".bmp"))
                {//open with picturebox control
                    webBrowserSend.Visible = false;
                    webBrowserSend.Height = 1;
                    webBrowserSend.Width = 1;
                    htmlEditor1.Visible = false;
                    richTextBoxSend.Visible = false;
                    pictureBoxSend.Visible = true;
                    pictureBoxSend.Dock = DockStyle.Fill;
                    Bitmap bmap = new Bitmap(fn);
                    Point bplocation = new Point(bmap.Size);
                    if (bplocation.X > pictureBoxSend.Width || bplocation.Y > pictureBoxSend.Height)
                        pictureBoxSend.SizeMode = PictureBoxSizeMode.Zoom;
                    else
                        pictureBoxSend.SizeMode = PictureBoxSizeMode.CenterImage;
                    pictureBoxSend.LoadAsync(fn);
                }

                if ((suff == ".doc") || (suff == ".pdf") || (suff == ".tmp") || (suff == ".htm"))
                {//open with webbrowser control
                    htmlEditor1.Visible = false;
                    richTextBoxSend.Visible = false;
                    pictureBoxSend.Visible = false;
                    webBrowserSend.Visible = true;
                    webBrowserSend.Dock = DockStyle.Fill;
                    webBrowserSend.Navigate(fn);
                }
            }

        }

        /// <summary>
        /// choose to send with html or plaintext
        /// </summary>
        private void rBtnPlainTxt_CheckedChanged(object sender, EventArgs e)
        {
            richTextBoxSend.Dock = DockStyle.Fill;
            richTextBoxSend.Visible = true;
            htmlEditor1.Visible = false;

        }

        private void rBtnHtml_CheckedChanged(object sender, EventArgs e)
        {
            htmlEditor1.Visible = true;
            richTextBoxSend.Visible = false;
        }
       
        

//**************************************************************************************
//-----------------------                             ----------------------------------
//-----------------------      Email Receive part     ----------------------------------
//-----------------------                             ----------------------------------
//**************************************************************************************


        TcpClient POP3Server; //TcpClient to connect to server
        NetworkStream POP3Stream; //Network stream to communicate with the server
        StreamReader StreamListener; //StreamReader to convert the binary data into readable text
        byte[] CommandBuffer = new byte[1024]; //Byte array to send commands to the server
        ASCIIEncoding AscEncoding = new ASCIIEncoding(); //ASCII encoding to convert binary data into ASCII code commands
        
        private void btnGetEmail_Click(object sender, EventArgs e)
        {
            string server = textBoxPopHost.Text;
            int port = 110;
            string user = textBoxUser.Text;
            string password = textBoxPass.Text;
            
            try
            {
                if (Connect(server, port, user, password))
                { 
                    
                    for (int i = 1; i <=int .Parse(mailinfo); i++)
                    {
                        read(i);
                        SaveMailArchiveIn(sender, textBoxSubjectTemp.Text);
                        //Program first stores the original data into mtx files, then load the selected mtx file
                        //and use function GetMailText to read the content and save attachment if there is one
                        if (checkBoxDelOnRead.Checked) Delete(i);
                    }                    
                    Quit();
                }
            }
            catch (Exception error)
            {
                MessageBox.Show(ErrorMess + error.Message, Fail, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        /// <summary>
        /// connect to mail server
        /// </summary>
        /// <param name="server">server name</param>
        /// <param name="port">port number</param>
        /// <param name="user">user name</param>
        /// <param name="password">user password</param>
        /// <returns></returns>
        private bool Connect(string server, int port, string user, string password)
        {
            POP3Server = new TcpClient();
            POP3Server.Connect(server, port); 
            POP3Stream = POP3Server.GetStream(); // Create Stream Network
            StreamListener = new StreamReader(POP3Stream); // to create StreamReader from network stream 

            if (POP3Server.Connected) // connection is successful
            {
                mailinfo = StreamListener.ReadLine();
                
                // Send Username
                CommandBuffer = AscEncoding.GetBytes("USER " + user + "\r\n");
                POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
                mailinfo = StreamListener.ReadLine();

                // Send password
                CommandBuffer = AscEncoding.GetBytes("PASS " + password + "\r\n");
                POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
                mailinfo = StreamListener.ReadLine();

                // Get the amount of mails on server
                CommandBuffer = AscEncoding.GetBytes("STAT " + "\r\n");
                POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
                mailinfo = StreamListener.ReadLine();
                string[] Array = mailinfo.Split(' ');
                mailinfo = Array[1];
                MessageBox.Show(mailinfo + " new message(s).");
                return true;
            }

            return false;
        }

        /// <summary>
        /// end the Connection to the POP3 server
        /// </summary>
        private void Quit()
        {           
            CommandBuffer = AscEncoding.GetBytes("QUIT\r\n");
            POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
            MessageBox.Show(StreamListener.ReadLine());
            POP3Stream.Close();
            POP3Server.Close();
        }

        ///<summary>
        ///delete the mails on server
        /// </summary>
        private void Delete(int mailNo)
        {
            CommandBuffer = AscEncoding .GetBytes ("DELE " + mailNo + "\r\n");
            POP3Stream .Write (CommandBuffer ,0,CommandBuffer .Length );
            MessageBox .Show (StreamListener .ReadLine ());
        }

        /// <summary>
        /// get the email from server and put it into a richtextbox
        /// </summary>
        /// <param name="mailNo">ID number of the mail</param>
        private void read(int mailNo)
        {
                richTextBoxMailArchiv.Text = ReadMailContent(mailNo );
                textBoxSubjectTemp.Text = strSubject;
        }

        /// <summary>
        /// Reads the contents of the mail from mail.
        /// </summary>
        /// <param name="mailNr">ID number of the mail</param>
        /// <returns>The contents of the mail.</returns>
        private string ReadMailContent(int mailNr)
        {
            // Command to read the corresponding email.
            CommandBuffer = AscEncoding.GetBytes("RETR " + mailNr + "\r\n");
            POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);

            // StringBuilder for rapid acquisition of the mail content.
            StringBuilder FullEmailContent = new StringBuilder();

            /* As long as not "." is read, the email is not over yet, read lines in the StringBuilder. */
            string TempLine = StreamListener.ReadLine();
            while (TempLine != ".")
            {
                if (TempLine.StartsWith("Subject"))
                {//get the subject from the mail. The subject will be used to name file when storing the mail.
                    strSubject = TempLine.Substring (9,TempLine .Length -9);
                }

                FullEmailContent.Append(TempLine + "\r\n");
                TempLine = StreamListener.ReadLine();
            }
            return FullEmailContent.ToString();
        }

        /// <summary>
        /// save email as mtx file
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="fileName">the subject which got in ReadMailContent</param>
        private void SaveMailArchiveIn(object sender, string fileName)
        {
            string[] files = System.IO.Directory.GetFiles(fileListBoxEmailRecv.Path);
            string dircont = EditFNroot.Text + EditMailbox.Text + "\\Inbox";
            string filen2, temp, clfn;
            
            //count the amount of files in the filelistbox control
            int cnt2 = files.Length, 
                i, actnb = 0;

            if (fileName == null) 
                fileName = "notitle";
            
            //to ensure that no illegal characters appear in file name
            clfn = clearfilename(fileName);

            if (cnt2 > 0)
            {
                for (i = cnt2; i > 0; i--)
                {
                    filen2 = fileListBoxEmailRecv.get_Items(i - 1);
                    actnb = GetNumber(filen2);
                    if (actnb > 0)
                        i = 0;
                }
                int nnb = actnb + 1;
                temp = "0000" + nnb.ToString();
                temp = temp.Substring(temp.Length - 4, 4) + "_";
            }
            else temp = "0000_";

            if (actnb < 9999)
            {
                richTextBoxMailArchiv.SaveFile(dircont + "\\" + temp + clfn + ".mtx", RichTextBoxStreamType.PlainText);
                fileListBoxEmailRecv.Refresh();
            }
            if (actnb >= 9999)
            {
                DialogResult strToomany = MessageBox.Show("Last number is too long", "information", MessageBoxButtons.OK);
            }
        }

        /// <summary>
        /// make the file name adapt to the naming rules, no illegal character
        /// </summary>
        /// <param name="fn">File name</param>
        /// <returns></returns>
        public static string clearfilename(string fn)
        {
            string newfn = "";
            for (int i = 0; i < fn.Length; i++)
            {
                if (fn.Substring(i, 1) != "/" && fn.Substring(i, 1) != ":" && fn.Substring(i, 1) != "*" && fn.Substring(i, 1) != "?"
                    && fn.Substring(i, 1) != "<" && fn.Substring(i, 1) != ">" && fn.Substring(i, 1) != "|"
                    && fn.Substring(i, 1) != "\"" && fn.Substring(i, 1) != "\\")
                    newfn += fn.Substring(i, 1);
            }
            return newfn;
        }

        /// <summary>
        /// Gets the prefix number in the filename
        /// </summary>
        /// <param name="fn">Filename</param>
        /// <returns>file number</returns>
        public int GetNumber(string fn)
        {                                  
            string a, nb = "";
            char[] test;
            char b;
            for (int i = 0; i < fn.Length; i++)
            {
                a = fn.Substring(i, 1);    // get character
                test = a.ToCharArray();
                b = test[0];
                if ((b >= '0') && (b <= '9')) nb = nb + a;
                else if (a == "_") return (Int32.Parse(nb));
                else return (-1);
            }
            //return -1, when no number exsisting
            return (-1);
        }

        /// <summary>
        /// invoke the DisplayMail method to display the selected mail
        /// </summary>
        private void fileListBoxEmailRecv_Click(object sender, EventArgs e)
        {
            if (fileListBoxEmailRecv.SelectedIndex >= 0)
                DisplayMail(sender, fileListBoxEmailRecv.SelectedItem.ToString());
            btnReply.Enabled = true;
        }

        /// <summary>
        /// Display selected email
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="fn">file name of the selected mail</param>
        private void DisplayMail(object sender, string fn)
        {
            richTextBoxBodyRecv.Clear();
            richTextBoxAttachRecv.Clear();
            listBoxAttachRecv.Items.Clear();
            webBrowserRecv.Visible = false;
            pictureBoxRecv.Visible = false;
            richTextBoxBodyRecv.Visible = true;

            //get the directory of the Inbox and load the file into a richtextbox 
            string dir = EditFNroot.Text + EditMailbox.Text + "\\Inbox";
            richTextBoxMailArchiv.LoadFile(dir + "\\" + fn, RichTextBoxStreamType.PlainText);

            if (richTextBoxMailArchiv.Text != "")
            {
                /* original mail text is separated into parts with "\n\n",
                 * headers like subject, time, return-path are in the first part, so 
                 * we use GetHeader to extract these headers from the beginging "0" to
                 * to end of the 1st part "\n\n"
                 */
                int endIndex = richTextBoxMailArchiv.Text.IndexOf("\n\n");
                GetHeader(richTextBoxMailArchiv.Text.Substring(0, endIndex));

                GetMailText(richTextBoxMailArchiv.Text);
            }
            else
            {
                richTextBoxBodyRecv .Text   = "Empty Email!";
            }
            
        }

        public void GetHeader(string emailheaders)
        {//Get the headers
            string[] str = emailheaders.Split('\n');
            foreach (string str1 in str)
            {
                if (str1.Trim().StartsWith("Subject:"))
                {
                    textBoxSubjectRecv.Text = str1.Substring(9, str1.Length - 9);
                }

                if (str1.Trim().StartsWith("Date:"))
                {
                    textBoxTimeRecv.Text = str1.Substring(6, str1.Length - 6);
                }

                if (str1.Trim().StartsWith("To: "))
                {
                    richTextBoxBodyRecv.AppendText("\n" + TxtTo + str1.Substring(4, str1.Length - 4));
                }

                if (str1.Trim().StartsWith("Cc: "))
                {
                    richTextBoxBodyRecv.AppendText("\n" + TxtCC + str1.Substring(4, str1.Length - 4));
                }

                if (str1.Trim().StartsWith("BCC: "))
                {
                    richTextBoxBodyRecv.AppendText("\n" + TxtBCC + str1.Substring(5, str1.Length - 5));
                }

                if (str1.Trim().StartsWith("From: "))
                {
                    textBoxSenderAddr.Text = str1.Substring(6, str1.Length - 6);
                    string senderName = GetTextType(str1, "From: \"", "\"").Replace("\"", "");
                    if (senderName == "")
                    {
                        richTextBoxBodyRecv.AppendText(TxtFrom + str1.Substring(6, str1.Length - 6));
                    }
                    else
                    {
                        richTextBoxBodyRecv.AppendText(TxtSender + senderName);
                        richTextBoxBodyRecv.AppendText("\n" + TxtFrom + "<" + GetTextType(str1, "<", ">"));
                    }
                }

            }
        }

        /// <summary>
        /// decode the whole text file received from the server, and display the information
        /// which users are concerned.
        /// </summary>
        /// <param name="mailtext">original text in a mail</param>
        public void GetMailText(string mailtext)
        {    
            int startIndex = -1, endIndex = -1;
            string ReturnText = "";
            string Transfer = "";
            string Boundary = "";
            string AttachDir = EditFNroot.Text + EditAttach.Text;

            //get the encoding
            string EncodingName = GetTextType(mailtext, "charset=\"", "\"").Replace("\"", "");
            System.Text.Encoding Encoding = System.Text.Encoding.Default;
            if (EncodingName != "")
                Encoding = System.Text.Encoding.GetEncoding(EncodingName);

            //get the type of the email, plain text or html or other types
            string convertType = GetTextType(mailtext, "Content-Type: ", ";");
            if (convertType.Length == 0)
            {
                convertType = GetTextType(mailtext, "Content-Type: ", "\r");
            }

            switch (convertType)
            {
                //if html, decode the text and save the content as html file into Anhang 
                case "text/html;":
                    Transfer = GetTextType(mailtext, "Content-Transfer-Encoding: ", "\n").Trim();
                    startIndex = mailtext.IndexOf("\n\n");
                    if (startIndex != -1)
                        ReturnText = mailtext.Substring(startIndex, mailtext.Length - startIndex);
                    switch (Transfer)
                    {
                        case "quoted-printable":
                            ReturnText = DecodeQuotedPrintable(ReturnText, Encoding);
                            break;
                        case "base64":
                            ReturnText = DecodeBase64(ReturnText, Encoding);
                            break;
                    }
                    richTextBoxBodyRecv.AppendText("\n" + TxtBody + "\n" + TxtBodyEnd);
                    richTextBoxAttachRecv.AppendText(ReturnText);
                    richTextBoxAttachRecv.SaveFile(AttachDir + "\\" + textBoxSubjectRecv.Text + ".htm", RichTextBoxStreamType.PlainText);
                    listBoxAttachRecv.Items.Add(textBoxSubjectRecv.Text + ".htm");
                    break;
                
                //if plain text, decode and show the content directly
                case "text/plain;":

                    Transfer = GetTextType(mailtext, "Content-Transfer-Encoding: ", "\n").Trim();
                    startIndex = mailtext.IndexOf("\n\n");
                    if (startIndex != -1)
                        ReturnText = mailtext.Substring(startIndex, mailtext.Length - startIndex);
                    switch (Transfer)
                    {
                        case "quoted-printable":
                            ReturnText = DecodeQuotedPrintable(ReturnText, Encoding);
                            break;
                        case "base64":
                            ReturnText = DecodeBase64(ReturnText, Encoding);
                            break;
                    }
                    richTextBoxBodyRecv.AppendText("\n" + TxtBody + ReturnText + "\n" + TxtBodyEnd);
                    break;
                
                //if mixed, seperate the content with boundary, and do the GetMailText again
                case "multipart/mixed;":
                    Boundary = GetTextType(mailtext, "boundary=", "\n").Trim();
                    startIndex = mailtext.IndexOf("--" + Boundary + "\n");
                    if (startIndex == -1) return;
                    while (true )
                    {
                        endIndex = mailtext.IndexOf("--" + Boundary, startIndex + Boundary.Length);
                        if (endIndex == -1) break;
                        string Temp = mailtext.Substring(startIndex, endIndex - startIndex);
                        GetMailText(Temp);
                        startIndex = endIndex;

                    }
                    break;
                
                //if email has attachment, decode and save it, and display the name of it in listbox
                default:
                    if (convertType.IndexOf("application/") == 0)
                    {
                        startIndex = mailtext.IndexOf("\n\n");
                        if (startIndex != -1)
                            ReturnText = mailtext.Substring(startIndex, mailtext.Length - startIndex);//.Replace ("\n","");
                        Transfer = GetTextType(mailtext, "Content-Transfer-Encoding: ", "\n").Trim();
                        string filename = GetTextType(mailtext, "name=\"", "\"").Replace ("\"","");
                        if (filename.Length == 0)
                        {
                            filename = GetTextType(mailtext, "name=", "\n").Replace ("\n","");
                        }
                        //richTextBoxBodyRecv.AppendText(filename + Transfer );
                        filename = GetReadText(filename);

                        if (File.Exists(AttachDir + "\\" + filename))
                        {
                            listBoxAttachRecv.Items.Add(filename);
                            break;
                        }
                        else
                        {
                            byte[] filebytes = new byte[0];
                            FileStream fs = new FileStream(AttachDir + "\\" + filename, FileMode.OpenOrCreate, FileAccess.ReadWrite);
                            switch (Transfer)
                            {
                                case "base64":

                                    filebytes = Convert.FromBase64String(ReturnText);

                                    break;
                            }
                            //richTextBoxAttachRecv.AppendText(ReturnText);
                            fs.Write(filebytes, 0, filebytes.Length);
                            listBoxAttachRecv.Items.Add(filename);
                            fs.Flush();
                            fs.Close();
                        }
                    }
                    break;
            }
        }

        /// <summary>
        /// using regular expression to find a specified text
        /// </summary>
        /// <param name="Mail">the text to analyze</param>
        /// <param name="TypeText">the start of the specified text</param>
        /// <param name="End">the end of the specified text</param>
        /// <returns>return the found text</returns>
        public string GetTextType(string Mail, string TypeText, string End)
        {
            System.Text.RegularExpressions.Regex Regex = new System.Text.RegularExpressions.Regex("(?<=" + TypeText + ").*?(" + End + ")");
            System.Text.RegularExpressions.MatchCollection Collection = Regex.Matches(Mail);
            if (Collection.Count == 0) return "";
            return Collection[0].Value;
        }

        /// <summary>
        /// decode the file name of attachment
        /// </summary>
        /// <param name="Text">the encoded file name</param>
        /// <returns>decoded file name</returns>
        public string GetReadText(string Text)
        {
            System.Text.RegularExpressions.Regex Regex = new System.Text.RegularExpressions.Regex(@"(?<=\=\?).*?(\?\=)+");
            System.Text.RegularExpressions.MatchCollection Collection = Regex.Matches(Text);
            string text = Text;
            foreach (System.Text.RegularExpressions.Match Match in Collection)
            {
                string Value = "=?" + Match.Value;
                if (Value[0] == '=')
                {
                    string[] BaseData = Value.Split('?');
                    if (BaseData.Length == 5)
                    {
                        System.Text.Encoding Coding = System.Text.Encoding.GetEncoding(BaseData[1]);
                        text = text.Replace(Value, Coding.GetString(Convert.FromBase64String(BaseData[3])));
                    }
                }
            }
            return text;
        }


        /// <summary>  
        /// decode QuotedPrintable 
        /// </summary>  
        /// <param name="Text">original text</param>  
        /// <param name="Encoding">encode mode</param>  
        /// <returns></returns>  
        public string DecodeQuotedPrintable(string Text, System.Text.Encoding Encoding)  
        {  
            System.IO.MemoryStream Stream = new System.IO.MemoryStream();  
            char[] CharValue = Text.ToCharArray();  
            for (int i = 0; i != CharValue.Length; i++)  
            {  
                switch (CharValue[i])  
                {  
                    case '=':  
                        if (CharValue[i + 1] == '\r' || CharValue[i + 1] == '\n')  
                        {  
                            i += 1;  
                        }  
                        else  
                        {  
                            try  
                            {  
                                Stream.WriteByte(Convert.ToByte(CharValue[i + 1].ToString() + CharValue[i + 2].ToString(), 16));  
                                i += 2;  
                            }  
                            catch  
                            {  
                                Stream.WriteByte(Convert.ToByte(CharValue[i]));  
                            }  
                        }  
                        break;  
                    default:  
                        Stream.WriteByte(Convert.ToByte(CharValue[i]));  
                        break;  
                }  
            }  
                return Encoding.GetString(Stream.ToArray());  
        }  
  
         /// <summary>  
         /// decode BASE64  
         /// </summary>  
         /// <param name="p_Text">original text</param>  
         /// <param name="Encoding">encode mode</param>  
         /// <returns></returns>  
        public string DecodeBase64(string Text, System.Text.Encoding Encoding)  
        {  
                if (Text.Trim().Length == 0) return "";  
                byte[] ValueBytes = Convert.FromBase64String(Text);  
                return Encoding.GetString(ValueBytes);  
        }

        /// <summary>
        /// give a preview of the attachment
        /// </summary>
        private void listBoxAttachRecv_Click(object sender, EventArgs e)
        {
            string fn, suff, AttachDir, fnd;
            if (listBoxAttachRecv.Items.Count > 0)
            {
                AttachDir = EditFNroot.Text + EditAttach.Text;
                fn = listBoxAttachRecv.Items[listBoxAttachRecv.SelectedIndex].ToString();
                fnd = AttachDir + "\\" + fn;
                suff = Path.GetExtension(fnd).ToLower();
                if ((suff == ".txt") || (suff == ".mtx") || (suff == ".rtf"))
                {
                    webBrowserRecv.Visible = false;
                    webBrowserRecv.Height = 1;
                    webBrowserRecv.Width = 1;
                    richTextBoxBodyRecv.Visible = false;
                    pictureBoxRecv.Visible = false;
                    richTextBoxRecv.Dock = DockStyle.Fill;
                    richTextBoxRecv.Visible = true;
                    if (suff == ".rtf")
                        richTextBoxRecv.LoadFile(fnd, RichTextBoxStreamType.RichText);
                    else
                        richTextBoxRecv.LoadFile(fnd, RichTextBoxStreamType.PlainText);
                }
                if ((suff == ".gif") || (suff == ".bmp"))
                {
                    webBrowserRecv.Visible = false;
                    webBrowserRecv.Height = 1;
                    webBrowserRecv.Width = 1;
                    richTextBoxBodyRecv.Visible = false;
                    richTextBoxRecv.Visible = false;
                    pictureBoxRecv.Visible = true;
                    pictureBoxRecv.Dock = DockStyle.Fill;
                    Bitmap bmap = new Bitmap(fnd);
                    Point bplocation = new Point(bmap.Size);
                    if (bplocation.X > pictureBoxRecv.Width || bplocation.Y > pictureBoxRecv.Height)
                        pictureBoxRecv.SizeMode = PictureBoxSizeMode.Zoom;
                    else
                        pictureBoxRecv.SizeMode = PictureBoxSizeMode.CenterImage;
                    pictureBoxRecv.Load(fnd);
                }

                if ((suff == ".jpg") || (suff == ".doc") || (suff == ".pdf") || (suff == ".tmp") || (suff == ".htm") || (suff == ".jpeg"))
                {
                    string OriginalPath = fnd;
                    string TempPath = EditFNroot.Text + "TempAttach" + "\\Temp" + fn;
                    File.Copy(OriginalPath, TempPath, true);
                    webBrowserRecv.Refresh();
                    richTextBoxBodyRecv.Visible = false;
                    richTextBoxRecv.Visible = false;
                    pictureBoxRecv.Visible = false;
                    webBrowserRecv.Visible = true;
                    webBrowserRecv.Dock = DockStyle.Fill;
                    webBrowserRecv.Navigate(TempPath );                
                }
            }
        }

        private void btnCloseView_Click(object sender, EventArgs e)
        {
            richTextBoxRecv.Visible = false;
            pictureBoxRecv.Visible = false;
            webBrowserRecv.Visible = false;
            richTextBoxBodyRecv.Visible = true;
        }

        /// <summary>
        /// Reply to a mail, and the text of the received mail will be copied
        /// to the new mail with a separator
        /// </summary>
        private void btnReply_Click(object sender, EventArgs e)
        {
            comboBoxReceiverAddr.Text = textBoxSenderAddr.Text;
            textBoxSubject.Text = "Re: " + textBoxSubjectRecv.Text;
            htmlEditor1.Text = "<hr>" + richTextBoxBodyRecv.Text.Replace (" ","&nbsp").Replace ("\n", @"<br />");
            richTextBoxSend.Text = "\n\n-------------------------------------------------------------\n"
                + richTextBoxBodyRecv.Text;
            tabCtrlEmail.SelectTab(tabPageWrite);
        }

        private void btnPrintEmail_Click(object sender, EventArgs e)
        {
            if (printDialog1.ShowDialog() == DialogResult.OK)
                printDocument1.Print();
        }

        /// <summary>
        /// delete the selected mail together with its attachment(s)
        /// </summary>
        private void btnDelEmail_Click(object sender, EventArgs e)
        {
            string fn, dir;
            int fSeleted = fileListBoxEmailRecv.SelectedIndex;
            if (fSeleted >= 0)
            {
                fn = fileListBoxEmailRecv.get_Items(fSeleted);
                dir = EditFNroot.Text + EditMailbox.Text + "\\Inbox";
                File.Delete(dir + "\\" + fn);

                //check if the mail contains attachment
                for (int i = 0; i < listBoxAttachRecv.Items.Count; i++)
                {
                    dir = EditFNroot.Text + EditAttach.Text;
                    fn = listBoxAttachRecv.Items[i].ToString();
                    listBoxAttachRecv.Items.Remove(listBoxAttachRecv.SelectedIndex);
                    File.Delete(dir + "\\" + fn);   
                }
                fileListBoxEmailRecv.Refresh();
                richTextBoxBodyRecv.Visible = false;
                textBoxSenderAddr.Text = "";
                textBoxSubjectRecv.Text = "";
                textBoxTimeRecv.Text = "";
                listBoxAttachRecv.Items.Clear();
                string[] files = System.IO.Directory.GetFiles(fileListBoxEmailRecv.Path);
                if (files.Length > 0)
                {
                    //cursor will move to the upper mail
                    if (fSeleted == files.Length)
                        fSeleted--;
                    fileListBoxEmailRecv.SetSelected(fSeleted, true);
                    fileListBoxEmailRecv_Click(sender, e);
                }
            }

        }

      //**************************************************************************************
      //-----------------------------                           ------------------------------
      //-----------------------------    Address Book part      ------------------------------
      //-----------------------------                           -----------------------------
      //**************************************************************************************
       
        private void btnUseSeletedAddr_Click(object sender, EventArgs e)
        {
            //copy the address in DataGridView into CopyList
            int row = dataGridAddrBook.CurrentRow.Index;
            if (dataGridAddrBook.RowCount > 0)
            {
                //program will check if user has chosen a proper row or the address is complete or not
                if (dataGridAddrBook[0, row].Value == null && dataGridAddrBook[1, row].Value == null)
                    MessageBox.Show("Empty row! Please select again.");
                else if (dataGridAddrBook[0, row].Value == null)//name is empty
                    listBoxCopyList.Items.Add(dataGridAddrBook[1, row].Value.ToString());
                else if (dataGridAddrBook[1, row].Value == null)
                    MessageBox.Show("Empty Email Address! Please check.");//email address is empty
                else//both name and addr are filled
                    listBoxCopyList.Items.Add(dataGridAddrBook[0, row].Value.ToString() +"<" +dataGridAddrBook[1, row].Value.ToString()+">");
            }
        }

        private void btnAddNewAddr_Click(object sender, EventArgs e)
        {//add one new row
            dataGridAddrBook.RowCount++;
            dataGridAddrBook.Rows[dataGridAddrBook.RowCount - 2].Selected = true;
            dataGridAddrBook.CurrentCell = dataGridAddrBook[0, dataGridAddrBook.RowCount - 2];
        }

        private void btnDelSeletedAddr_Click(object sender, EventArgs e)
        {// delete a seleted address
            int currentRow = dataGridAddrBook.CurrentRow.Index;
            int countRow = dataGridAddrBook.RowCount - 1;
            if (countRow > 0)
            {
                for (int i = currentRow; i < currentRow; i++)
                {//move the names and addresses to the upper row
                    dataGridAddrBook[0, i].Value = dataGridAddrBook[0, i + 1].Value;
                    dataGridAddrBook[1, i].Value = dataGridAddrBook[1, i + 1].Value;
                }
                dataGridAddrBook.RowCount--;
            }
        }

        /// <summary>
        /// Store a address list as a INI-file 
        /// </summary>
        private void btnSaveAddrList_Click(object sender, EventArgs e)
        {
            FormSaveAddrList FSAL = new FormSaveAddrList();
            FSAL.ShowDialog();
            if (FSAL.Tag.ToString() == "1")
            {//btnSave pressed
                if (!File.Exists(EditFNroot.Text + FSAL.textBoxAddrListName.Text + ".int"))
                {
                    listBoxAddrListTemp.Items.Clear();
                    for (int i = 0; i < dataGridAddrBook.RowCount - 1; i++)
                    {
                        //make the format of addresses look like name<email address> 
                        if (dataGridAddrBook.Rows [i].Cells [0].Value == null)
                            listBoxAddrListTemp.Items.Add(dataGridAddrBook.Rows [i].Cells [1].Value.ToString());
                        else
                            listBoxAddrListTemp.Items.Add(dataGridAddrBook.Rows [i].Cells [0].Value.ToString() +"<"+ dataGridAddrBook.Rows [i].Cells [1].Value.ToString()+">");
                    }
                    StreamWriter SW = File.CreateText(EditFNroot.Text + FSAL.textBoxAddrListName.Text + ".ini");
                    for (int i = 0; i < listBoxAddrListTemp.Items.Count; i++)
                    {// write the addresses into the  specified file
                        SW.WriteLine(listBoxAddrListTemp.Items[i].ToString());
                    }
                    SW.Flush();
                    SW.Close();
                }
            }                  
        }
        
        private void LoadFromFile(string fn)
        {// load address list file from local
            FileStream filestr = new FileStream(fn, FileMode.Open);
            StreamReader strRead = new StreamReader(filestr, System.Text.Encoding.Default);
            listBoxAddrListTemp.Items.Clear();

            string line;

            while ((line = strRead.ReadLine()) != null)
            {
                listBoxAddrListTemp.Items.Add(line);
            }
            filestr.Close();
            dataGridAddrBook.RowCount = listBoxAddrListTemp.Items.Count + 1;
            string a, name, address;
            for (int i = 0; i < listBoxAddrListTemp.Items.Count; i++)
            {
                a = listBoxAddrListTemp.Items[i].ToString();
                if (a.Contains("<") && a.Contains(">"))
                {
                    if (a.Substring(0, 1) == "<")
                    {
                        address = a.Substring(1, a.Length - 2);
                        name = "";
                    }
                    else
                    {
                        address = a.Substring(a.IndexOf("<") + 1, a.IndexOf(">") - a.IndexOf("<") - 1);
                        name = a.Substring(0, a.IndexOf("<"));
                    }
                }
                else
                {
                    address = a;
                    name = "";
                }
                dataGridAddrBook[1, i].Value = address;
                dataGridAddrBook[0, i].Value = name;
            }
        }


        private void btnPrintAddrList_Click(object sender, EventArgs e)
        {// print out the address list
            if (printDialog1.ShowDialog() == DialogResult.OK)
            {
                richTextBoxMailArchiv.Clear();
                for (int i = 0; i < dataGridAddrBook.RowCount - 1; i++)
                {
                    if (dataGridAddrBook[0, i].Value.ToString() == "")
                        richTextBoxMailArchiv.AppendText("<"+ dataGridAddrBook[1, i].Value.ToString()+ ">"+ "\r\n");
                    else
                        richTextBoxMailArchiv.AppendText(dataGridAddrBook[0, i].Value.ToString() + "<"+dataGridAddrBook[1, i].Value.ToString() +">"+ "\r\n");
                }
                printDocument1.Print();
            }
        }
        
        private void printDocument1_BeginPrint(object sender, System.Drawing.Printing.PrintEventArgs e)
        {
            checkprintEmail = 0;
        }

        private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            checkprintEmail = richTextBoxMailArchiv.Print(checkprintEmail, richTextBoxMailArchiv.TextLength, e);
            if (checkprintEmail < richTextBoxMailArchiv.TextLength)
                e.HasMorePages = true;
            else
                e.HasMorePages = false;
        }

        private void btnCleanAddrList_Click(object sender, EventArgs e)
        {
            dataGridAddrBook.Rows.Clear();
        }

        private void btnLoadOtherList_Click(object sender, EventArgs e)
        {// load list with function of LoadFromFile
            OpenFileDialog Openfile = new OpenFileDialog();
            Openfile.InitialDirectory = EditFNroot.Text;
            if (Openfile.ShowDialog() == DialogResult.OK)
                LoadFromFile(Openfile.FileName);
        }

        
        private void comboBoxSearch_TextChanged(object sender, EventArgs e)
        {//search the address list for the address which has the same pattern as the one user typed in
            string addr, search = comboBoxSearch.Text.ToLower();
            listBoxSearchList.Items.Clear();
            if (search.Length > 0)
            {
                for (int i = 0; i < dataGridAddrBook.RowCount-1; i++)
                {
                    for (int j = 0; j < 2; j++)
                    {
                        addr = dataGridAddrBook[j,i].Value.ToString().ToLower();
                        if (addr.Contains(search))
                        {
                            dataGridAddrBook.Rows[i].Selected = true;
                            dataGridAddrBook.CurrentCell = dataGridAddrBook.Rows[i].Cells[j];
                            if (dataGridAddrBook[0, i].Value == null)
                            {
                                listBoxSearchList.Items.Add(dataGridAddrBook[1, i].Value.ToString());
                            }
                            else
                            {
                                listBoxSearchList.Items.Add(dataGridAddrBook[0, i].Value.ToString() +"<"+ dataGridAddrBook[1, i].Value.ToString()+ ">");
                            }
                            if (listBoxSearchList.Items.Count > 20)
                            {
                                i += 100;
                            }
                        }
                    }
                }
            }
            if (listBoxSearchList.Items.Count == 0)
            {
                dataGridAddrBook.Rows[dataGridAddrBook.RowCount - 1].Selected = true;
                dataGridAddrBook.CurrentCell = dataGridAddrBook[0, dataGridAddrBook.RowCount - 1];
            }
            else
            {
                listBoxSearchList.SelectedIndex = 0;
            }

            for (int i = 0; i < listBoxSearchList.Items.Count; i++)
            {//remove the same result in listbox
                for (int j = i + 1; j < listBoxSearchList.Items.Count; j++)
                {
                    if (listBoxSearchList.Items[i].Equals(listBoxSearchList.Items[j]))
                        listBoxSearchList.Items.Remove(listBoxSearchList.Items[j]);
                }
            }
        }

        private void listBoxSearchList_Click(object sender, EventArgs e)
        {//cursor of DataGridView will point to the address which user is clicked in the search list
            if (listBoxSearchList.Items.Count > 0)
            {
                string a = listBoxSearchList.Items[listBoxSearchList.SelectedIndex].ToString();
                for (int i = 0; i < dataGridAddrBook.RowCount - 1; i++)
                {
                    if ((dataGridAddrBook[0, i].Value.ToString()+"<" + dataGridAddrBook[1, i].Value.ToString()+">") == a)
                    {
                        dataGridAddrBook.Rows[i].Selected = true;
                        dataGridAddrBook.CurrentCell = dataGridAddrBook.Rows[i].Cells[0];
                    }
                }
            }

        }

        private void listBoxSearchList_DoubleClick(object sender, EventArgs e)
        {// add address to Copy list
            if (listBoxSearchList.Items.Count > 0)
            {
                listBoxCopyList.Items.Add(listBoxSearchList.Items[listBoxSearchList.SelectedIndex].ToString());
            }
        }

        private void btnSearchAdd_Click(object sender, EventArgs e)
        {// add address to Copy list
            if (listBoxSearchList.Items.Count > 0)
                listBoxSearchList_DoubleClick(sender, e);
        }

        private void btnAddmailAddr_Click(object sender, EventArgs e)
        {// add address to Copy list
            if (textBoxMailAddr .Text !="")
                listBoxCopyList .Items .Add (textBoxMailAddr .Text );
                textBoxMailAddr .Clear ();
        }

        private void btnOK_Click(object sender, EventArgs e)
        {
            //copy the addresses in CopyList to recipient
            if (ReceiveAddr)
            {
                comboBoxReceiverAddr.Items.Clear();

                if (listBoxCopyList.Items.Count > 0)
                {
                    for (int i = 1; i < listBoxCopyList.Items.Count; i++)
                    {
                        comboBoxReceiverAddr.Items.Add(listBoxCopyList.Items[i]);
                    }
                    comboBoxReceiverAddr.Text = listBoxCopyList.Items[0].ToString();
                }
            }
            //copy the addresses in CopyList to CC
            if (CcAddr)
            {
                comboBoxCCAddr.Items.Clear();
                if (listBoxCopyList.Items.Count > 0)
                {
                    for (int i = 1; i < listBoxCopyList.Items.Count; i++)
                    {
                        comboBoxCCAddr.Items.Add(listBoxCopyList.Items[i]);
                    }
                    comboBoxCCAddr.Text = listBoxCopyList.Items[0].ToString();
                }

                CcAddr = false;
            }
            //copy the addresses in CopyList to BCC
            if (BCCAddr)
            {
                comboBoxBCCAddr.Items.Clear();
                if (listBoxCopyList.Items.Count > 0)
                {
                    for (int i = 0; i < listBoxCopyList.Items.Count; i++)
                    {
                        comboBoxBCCAddr.Items.Add(listBoxCopyList.Items[i]);
                    }
                    comboBoxBCCAddr.Text = listBoxCopyList.Items[0].ToString();
                }

                BCCAddr = false;
            }
            listBoxCopyList.Items.Clear();
            tabCtrlEmail.SelectTab(tabPageWrite);
            listBoxCopyList.Items.Clear();
        }

        private void btnDelete_Click(object sender, EventArgs e)
        {//delete the selected item in CopyList
            listBoxCopyList.Items.RemoveAt(listBoxCopyList.SelectedIndex);
        }

        private void btnEmptyList_Click(object sender, EventArgs e)
        {//empty the CopyList
            listBoxCopyList.Items.Clear();
        }

//*****************************************************************************************
//----------------------------------                        -------------------------------
//---------------------------------     Setting Page        -------------------------------
//----------------------------------                        -------------------------------
//*****************************************************************************************

        private void SettingsLoad()
        {// Load settings.ini file
            try
            {
                FileStream fstr = new FileStream("Settings.ini", FileMode.Open);
                StreamReader sr = new StreamReader(fstr, System.Text.Encoding.Default);
                System.Collections.ObjectModel.Collection<string> clist
                = new System.Collections.ObjectModel.Collection<string>();
                string line;
                while ((line = sr.ReadLine()) != null)
                {
                    clist.Add(line);
                }
                EditFNroot.Text = clist[0];
                EditMailbox.Text = clist[1];
                EditAttach.Text = clist[2];
                EditBilderordner.Text = clist[3];
                EditCont.Text = clist[4];
                textBoxUser.Text = clist[5];
                textBoxPass.Text = clist[6];
                textBoxSMTPHost.Text = clist[7];
                textBoxPopHost.Text = clist[8];
                textBoxFrom.Text = clist[9];
                textBoxFromName.Text = clist[10];
                textBoxPort.Text = clist[11];
            }
            catch (Exception error)
            {
                MessageBox.Show(ErrorMess + error.Message, Fail, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }

        private void btnSaveSetting_Click(object sender, EventArgs e)
        {
            SettingsSave();
            MessageBox.Show("Settings successfully saved!");
        }
        
        private void SettingsSave()
        {
            richTextBoxSettings.Clear();
            richTextBoxSettings.AppendText(EditFNroot.Text + "\r\n");
            richTextBoxSettings.AppendText(EditMailbox.Text + "\r\n");
            richTextBoxSettings.AppendText(EditAttach.Text + "\r\n");
            richTextBoxSettings.AppendText(EditBilderordner.Text + "\r\n");
            richTextBoxSettings.AppendText(EditCont.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxUser.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxPass.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxSMTPHost.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxPopHost.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxFrom.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxFromName.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxPort.Text + "\r\n");
            richTextBoxSettings.SaveFile(EditFNroot.Text + "Settings.ini", RichTextBoxStreamType.PlainText);
        }

    }
}
