﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.Mail;
using System.Net.Sockets;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Email_simple
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            SettingsLoad();
        }


        public string Copylist = "Copy-list", Warning = "Warning", ErrorMess = "Error message:", Fail = "Fail";
        string TxtTo = "--- To:", TxtCC = "--- CC:", TxtBCC = "--- BCC:", TxtSender = "--- Sender:", TxtFrom = "--- From:", TxtEnd = "--- End",
           TxtBody = "--- Text:", TxtBodyEnd = "--- End Text";

 
        public string cannotempty = "The name cannot be empty";
        private void btnSaveSetting_Click(object sender, EventArgs e)
        {
            SettingsSave();
            MessageBox.Show("Settings successfully saved!");
        }



        //*****************************************************************************************
        //----------------------------------                        -------------------------------
        //---------------------------------     Setting Page        -------------------------------
        //----------------------------------                        -------------------------------
        //*****************************************************************************************

        private void SettingsLoad()
        {// Load settings.ini file
            try
            {
                FileStream fstr = new FileStream("Settings.ini", FileMode.Open);
                StreamReader sr = new StreamReader(fstr, System.Text.Encoding.Default);
                System.Collections.ObjectModel.Collection<string> clist
                = new System.Collections.ObjectModel.Collection<string>();
                string line;
                while ((line = sr.ReadLine()) != null)
                {
                    clist.Add(line);
                }
                EditFNroot.Text = clist[0];
                EditMailbox.Text = clist[1];
                comboBoxReceiverAddr.Text = clist[1];  // Default Empfänger
                EditAttach.Text = clist[2];
                EditBilderordner.Text = clist[3];
                EditCont.Text = clist[4];
                textBoxUser.Text = clist[5];
                textBoxPass.Text = clist[6];
                textBoxSMTPHost.Text = clist[7];
                textBoxPopHost.Text = clist[8];
                textBoxFrom.Text = clist[9];
                textBoxFromName.Text = clist[10];
                textBoxPort.Text = clist[11];
                sr.Close();
            }
            catch (Exception error)
            {
                MessageBox.Show(ErrorMess + error.Message, Fail, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }


        private void SettingsSave()
        {
            richTextBoxSettings.Clear();
            richTextBoxSettings.AppendText(EditFNroot.Text + "\r\n");
            richTextBoxSettings.AppendText(EditMailbox.Text + "\r\n");
            richTextBoxSettings.AppendText(EditAttach.Text + "\r\n");
            richTextBoxSettings.AppendText(EditBilderordner.Text + "\r\n");
            richTextBoxSettings.AppendText(EditCont.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxUser.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxPass.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxSMTPHost.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxPopHost.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxFrom.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxFromName.Text + "\r\n");
            richTextBoxSettings.AppendText(textBoxPort.Text + "\r\n");
            richTextBoxSettings.SaveFile("Settings.ini", RichTextBoxStreamType.PlainText);
        }
        //*******************************************************************************
        //--------------------                                  -------------------------
        //--------------------       Email Send part            -------------------------
        //--------------------                                  -------------------------        
        //*******************************************************************************

        /// <summary>
        /// Email send
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnSendEmail_Click(object sender, EventArgs e)
        {
            try
            {
                if (comboBoxReceiverAddr.Text != "")
                {
                    MailMessage Email = new MailMessage();

                    MailAddress Sender = new MailAddress(textBoxFrom.Text);
                    Email.From = Sender;

                    Email.To.Add(comboBoxReceiverAddr.Text);
                    if (comboBoxReceiverAddr.Items.Count > 0)
                    {//more than one recipient
                        for (int i = 0; i < comboBoxReceiverAddr.Items.Count; i++)
                        {
                            Email.To.Add(comboBoxReceiverAddr.Items[i].ToString());
                        }
                    }

                    Email.Subject = textBoxSubject.Text;
                    Email.Body = tBSend.Text;
                    
                    // hier folgt Möglichkeit CC und BCC und Attachments zu ergänzen. Ist wegkommentiert
                    ////send email with CC 
                    //if (comboBoxCCAddr.Text != "")
                    //    Email.CC.Add(comboBoxCCAddr.Text);
                    //if (comboBoxCCAddr.Items.Count > 0)
                    //{//more than one CC
                    //    for (int i = 0; i < comboBoxCCAddr.Items.Count; i++)
                    //    {
                    //        Email.To.Add(comboBoxCCAddr.Items[i].ToString());
                    //    }
                    //}
                    ////send email with BCC
                    //if (comboBoxBCCAddr.Text != "")
                    //    Email.Bcc.Add(comboBoxBCCAddr.Text);
                    //if (comboBoxBCCAddr.Items.Count > 0)
                    //{//more than one BCC
                    //    for (int i = 0; i < comboBoxBCCAddr.Items.Count; i++)
                    //    {
                    //        Email.To.Add(comboBoxBCCAddr.Items[i].ToString());
                    //    }
                    //}

                    //email has attachment or not
                    //if (listBoxAttachSend.Items.Count > 0)
                    //{
                    //    for (int i = 0; i < listBoxAttachSend.Items.Count; i++)
                    //    {// add attachment to email
                    //        Attachment attach = new Attachment(listBoxAttachSend.Items[i].ToString());
                    //        Email.Attachments.Add(attach);
                    //    }
                    //}

                    string ServerName = textBoxSMTPHost.Text;
                    string Port = textBoxPort.Text;

                    SmtpClient MailClient = new SmtpClient(ServerName, int.Parse(Port));

                    string UserName = textBoxUser.Text;
                    string Password = textBoxPass.Text;

                    System.Net.NetworkCredential Credentials = new System.Net.NetworkCredential(UserName, Password);

                    MailClient.Credentials = Credentials;

                    MailClient.Send(Email);
                    //MessageBox.Show("Email is sent successfully!");

                }
            }
            catch (Exception error)
            {
                MessageBox.Show(ErrorMess + error.Message, Fail, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }


        //**************************************************************************************
        //-----------------------                             ----------------------------------
        //-----------------------      Email Receive part     ----------------------------------
        //-----------------------                             ----------------------------------
        //**************************************************************************************


        TcpClient POP3Server; //TcpClient to connect to server
        NetworkStream POP3Stream; //Network stream to communicate with the server
        StreamReader StreamListener; //StreamReader to convert the binary data into readable text

        private void timer1_Tick(object sender, EventArgs e)
        {
            btnGetEmail_Click(null, null);
        }

        private void butStartStop_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled)
            {
                timer1.Enabled = false;
                butStartStop.Text = "Start";
            }else
            {
                timer1.Enabled = true;
                butStartStop.Text = "Stop";
            }
        }

        byte[] CommandBuffer = new byte[1024]; //Byte array to send commands to the server
        ASCIIEncoding AscEncoding = new ASCIIEncoding(); //ASCII encoding to convert binary data into ASCII code commands
        string mailinfo;//store the connection infomation
        string strSubject;//store mail subject temporarily


        private void btnGetEmail_Click(object sender, EventArgs e)
        {
            string server = textBoxPopHost.Text;
            int port = 110;
            string user = textBoxUser.Text;
            string password = textBoxPass.Text;
            label1.Visible = false;
            try
            {
                if (Connect(server, port, user, password))
                {
                   
                    for (int i = 1; i <= int.Parse(mailinfo); i++)
                    {
                        read(i);
                        //SaveMailArchiveIn(sender, textBoxSubjectTemp.Text);
                        //Program first stores the original data into mtx files, then load the selected mtx file
                        //and use function GetMailText to read the content and save attachment if there is one
                        if (checkBoxDelOnRead.Checked) Delete(i);
                    }
                     Quit(); 
                }
            }
            catch (Exception error)
            {
                MessageBox.Show(ErrorMess + error.Message, Fail, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }

        }
        private bool Connect(string server, int port, string user, string password)
        {
            POP3Server = new TcpClient();
            POP3Server.Connect(server, port);
            POP3Stream = POP3Server.GetStream(); // Create Stream Network
            StreamListener = new StreamReader(POP3Stream); // to create StreamReader from network stream 

            if (POP3Server.Connected) // connection is successful
            {
                mailinfo = StreamListener.ReadLine();

                // Send Username
                CommandBuffer = AscEncoding.GetBytes("USER " + user + "\r\n");
                POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
                mailinfo = StreamListener.ReadLine();

                // Send password
                CommandBuffer = AscEncoding.GetBytes("PASS " + password + "\r\n");
                POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
                mailinfo = StreamListener.ReadLine();

                // Get the amount of mails on server
                CommandBuffer = AscEncoding.GetBytes("STAT " + "\r\n");
                POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
                mailinfo = StreamListener.ReadLine();
                string[] Array = mailinfo.Split(' ');
                mailinfo = Array[1];
                //MessageBox.Show(mailinfo + " new message(s).");
                label3.Text=mailinfo + " Mails im Posteingang";
               
                return true;
            }

            return false;
        }
        private void Quit()
        {
            CommandBuffer = AscEncoding.GetBytes("QUIT\r\n");
            POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
            //MessageBox.Show(StreamListener.ReadLine());
            POP3Stream.Close();
            POP3Server.Close();
        }
        private void Delete(int mailNo)
        {
            CommandBuffer = AscEncoding.GetBytes("DELE " + mailNo + "\r\n");
            POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);
            //MessageBox.Show(StreamListener.ReadLine());
        }
        private void read(int mailNo)
        {
            richTextBox1.Text = ReadMailContent(mailNo);
            textBoxSubjectTemp.Text = strSubject;
            if (strSubject.Length > 0)
                if (strSubject.Substring(0, 1) == "!")
                {
                    // Erzeuge Alarmmeldung und sende Quittung und lösche diese Mail
                    label1.Text = strSubject.Substring(1);
                    label1.Visible = true;
                    Delete(mailNo);
                    comboBoxReceiverAddr.Text = textBoxSenderAddr.Text;
                    tBSend.AppendText(textBoxTimeRecv.Text);
                    btnSendEmail_Click(null, null);
                }
        }
        private string ReadMailContent(int mailNr)
        {
            // Command to read the corresponding email.
            CommandBuffer = AscEncoding.GetBytes("RETR " + mailNr + "\r\n");
            POP3Stream.Write(CommandBuffer, 0, CommandBuffer.Length);

            // StringBuilder for rapid acquisition of the mail content.
            StringBuilder FullEmailContent = new StringBuilder();

            /* As long as not "." is read, the email is not over yet, read lines in the StringBuilder. */
            string TempLine = StreamListener.ReadLine();
            while (TempLine != ".")
            {
                if (TempLine.StartsWith("Subject"))
                {//get the subject from the mail. The subject will be used to name file when storing the mail.
                    strSubject = TempLine.Substring(9, TempLine.Length - 9);
                    textBoxSubjectRecv.Text = strSubject;
                }
                if (TempLine.Trim().StartsWith("Date:"))
                {
                    textBoxTimeRecv.Text = TempLine.Substring(6, TempLine.Length - 6);
                }

                if (TempLine.Trim().StartsWith("From: "))
                {
                    int startpos = TempLine.IndexOf("<");
                    int endpos= TempLine.IndexOf(">");
                    textBoxSenderAddr.Text = TempLine.Substring(startpos + 1, TempLine.Length - startpos - 2);
                }
                    FullEmailContent.Append(TempLine + "\r\n");
                TempLine = StreamListener.ReadLine();
            }
            return FullEmailContent.ToString();
        }


    }
}
