﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


using System.Diagnostics;   // für stopwatch
// Version mit MicroTimer Feb 2018
                     
namespace MMTimercheck
{
    public partial class Form1 : Form
    {

        private readonly MicroLibrary.MicroTimer _microTimer;
        long[] histT0 = new long[1000];
        double MaxT0 = 0;
        long histcnt = 0;
        Stopwatch stopwatch1 = new Stopwatch();

        public Form1()
        {
            InitializeComponent();
            // Instantiate new MicroTimer and add event handler
            _microTimer = new MicroLibrary.MicroTimer();
            _microTimer.MicroTimerElapsed +=
                new MicroLibrary.MicroTimer.MicroTimerElapsedEventHandler(OnTimedEvent);
            stopwatch1.Start();
        }

        bool run = false;
        private void butStart_Click(object sender, EventArgs e)
        {
            _microTimer.Interval = 1000;   /// µSec

            histcnt = 0;
            for (int i = 0; i < histT0.Length; i++)
                histT0[i] = 0;

            MaxT0 = 0;
            maxhistT0 = 0;
            _microTimer.Start();
            Application.DoEvents();

            t0start = -1;
            run = true;

        }

        private void butStop_Click(object sender, EventArgs e)
        {
            run = false;
            Application.DoEvents();
            _microTimer.Stop();
            int nb = histT0.Length;
            chart2D1.clearAll();
            chart2D1.XMax = 10;
            for (int i = 0; i < nb; i++)
             
            {
                chart2D1.setPoint(0, i / 100.0, 1.0*histT0[i]);  //   /maxhistT0  Wenn man durch maxhistT0 teilt, gibt es normierte Anzeige
            }
            chart2D1.XGrid = true;
            chart2D1.YGrid = true;
            labelMaxT0.Text = " Max T0: " + (MaxT0 * 1000.0 / Stopwatch.Frequency).ToString("f2") + " ms";

        }

        long t0end = 0, t0start = 0;
        long maxhistT0 = 0;

        private void OnTimedEvent(object sender,MicroLibrary.MicroTimerEventArgs timerEventArgs)
        {
            if (run)
            {
                t0end = t0start;
                t0start = stopwatch1.ElapsedTicks;
                double deltaT0;
                if (t0end > 0)
                {
                    deltaT0 = t0start - t0end;
                    // Hier kann Berechnung stehen

                    int Hwert = (int)Math.Round(deltaT0 * 100000.0 / Stopwatch.Frequency);// Vielfaches von 10 µsec
                    if (deltaT0 > MaxT0) MaxT0 = deltaT0;
                    if (Hwert > 999)
                    {
                        Hwert = 999;
                    }
                    histT0[Hwert]++;
                    if (histT0[Hwert] > maxhistT0) maxhistT0 = histT0[Hwert];
                    histcnt++;
                }
            }

        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            // Stop the timer, wait for up to 1 sec for current event to finish,
            //  if it does not finish within this time abort the timer thread
            if (!_microTimer.StopAndWait(1000))
            {
                _microTimer.Abort();
            }

        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            label1.Text = histcnt.ToString();
            labelMaxT0.Text = " Max T0: " + (MaxT0 * 1000.0 / Stopwatch.Frequency).ToString("f2") + " ms";
            labMaxHist.Text = maxhistT0.ToString();
        }
    }
}
