﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO.Ports;
using System.IO;


namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void buttonOpen_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
            
            serialPort1.Open();

            if(serialPort1.IsOpen)
            {
                //buttonReadLine.Enabled=true;  // ist gefährlich, da Programm dann auf CR wartet, wenn keines kommt --> Tot
                buttonSend.Enabled=true;
                buttonStratRec.Enabled = true;
                label2.Text=serialPort1.PortName+"  is now open";
            } else
                label2.Text = "No Port is open";
        }

        private void buttonSend_Click(object sender, EventArgs e)
        {
            string tx = textBox2.Text;
            if (cBSendWithLF.Checked) serialPort1.WriteLine(tx);
            else serialPort1.Write(tx);
        }

        private void comboBox1_SelectedValueChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.PortName = cbPort.Text;


        }

        private void Check_Click(object sender, EventArgs e)
        {
            cbPort.Items.Clear();

            foreach (string s in SerialPort.GetPortNames())
            {
                cbPort.Items.Add(s);
            }

        }

        private void buttonStratRec_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) 
                if (timer1.Enabled)
                {
                    timer1.Enabled = false;
                    buttonStratRec.Text = "Start again";
                }
                else
                {
                    timer1.Enabled = true;
                    buttonStratRec.Text = "Stop";
                }
        }
        
        string inp="";
        
        private void timer1_Tick(object sender, EventArgs e)
        {
            toolStripStatusLabel1.Text = DateTime.Now.ToString();// only to see thats timer is running
            if (serialPort1.BytesToRead > 0)
            {
                for (int i = 0; i < serialPort1.BytesToRead; i++)
                {
                    int c = serialPort1.ReadChar();
                    char ch=(char)c;
                    string hx=c.ToString("X2");
                    if (rBInt.Checked) inp = inp + c.ToString()+" ";
                    if (rBHex.Checked) inp = inp + hx + " ";
                    if (rBChar.Checked) inp=inp+ch;
                }
                textBox1.AppendText(inp);
                inp = "";
            }
        }

        private void buttonReadLine_Click(object sender, EventArgs e)
        {
            textBox1.AppendText(serialPort1.ReadLine());//
        }

        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            buttonClose_Click(sender, e);
            serialPort1.BaudRate=int.Parse(comboBox1.Text);

        }

        private void buttonLoad_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamReader myStream1 = new StreamReader(openFileDialog1.OpenFile(),Encoding.Default);
                textBox2.Text = myStream1.ReadToEnd();
            }
        }

        private void buttonClose_Click(object sender, EventArgs e)
        {
            serialPort1.Close();
            label2.Text = " No COM open";
            timer1.Enabled = false;
            buttonSend.Enabled = false;
            buttonStratRec.Enabled = false;


        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBox2.Clear();
        }

        private void buttonClearTB1_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
        }
    }
}
