﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Stringbuilder
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            stw.Start();
        }

        Stopwatch stw = new Stopwatch();
        private void butLoad_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                StreamReader mystr = new StreamReader(openFileDialog1.OpenFile(),Encoding.Default);
                textBox1.Text = mystr.ReadToEnd();
                mystr.Close();
                label2.Text = "File: " + openFileDialog1.FileName;
            }
        }

        private void butZähleLeerz_Click(object sender, EventArgs e)
        {
            string a = textBox1.Text;
            long st = stw.ElapsedTicks;
            int cnt = 0, pos = -1;
            do
            {
                pos = a.IndexOf("  ", pos + 1);
                if (pos >= 0) cnt++;
            } while (pos >= 0);
            long time = stw.ElapsedTicks - st;
            label1.Text = cnt.ToString();
            labTime.Text ="Zeit="+ (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3")+ " msec";
        }

        private void butReplace1_Click(object sender, EventArgs e)
        {
            int cnt = 0;
            string a = textBox1.Text;
            long st = stw.ElapsedTicks;

            do
            {
                a = a.Replace("  ", " ");
                int pos = -1;
                cnt = 0;
                do
                {
                    pos = a.IndexOf("  ", pos + 1);
                    if (pos >= 0) cnt++;
                } while (pos >= 0);

            } while (cnt > 0);
            long time = stw.ElapsedTicks - st;

            textBox1.Text = a;
            labTime.Text = "Zeit=" + (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3") + " msec";
        }

        private void butZählSB_Click(object sender, EventArgs e)
        {
            // geht nicht, kein IndexOf
            labTime.Text = "geht nicht";
        }

        private void butReplSB_Click(object sender, EventArgs e)
        {
            int cnt = 0;
            StringBuilder a = new StringBuilder( textBox1.Text);
            long st = stw.ElapsedTicks;

            do
            {
                a = a.Replace("  ", " ");
                int pos = -1;
                cnt = 0;
                do
                {
                    //pos = a.IndexOf("  ", pos + 1);  //indexOf geht bei Stringbuilder nicht
                    if (pos >= 0) cnt++;
                } while (pos >= 0);

            } while (cnt > 0);
            long time = stw.ElapsedTicks - st;

            textBox1.Text = a.ToString();
            labTime.Text = "Zeit=" + (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3") + " msec";

        }

        private void butRepl10_Click(object sender, EventArgs e)
        {

            string a = textBox1.Text;
            long st = stw.ElapsedTicks;

            for (int i = 0; i < 10; i++)
                a = a.Replace("  ", " ");

            long time = stw.ElapsedTicks - st;

            textBox1.Text = a;
            labTime.Text = "Zeit=" + (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3") + " msec";

        }

        private void butRepl10SB_Click(object sender, EventArgs e)
        {
            StringBuilder a = new StringBuilder( textBox1.Text);
            long st = stw.ElapsedTicks;

            for (int i = 0; i < 10; i++)
                a.Replace("  ", " ");

            long time = stw.ElapsedTicks - st;

            textBox1.Text = a.ToString();
            labTime.Text = "Zeit=" + (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3") + " msec";

        }

        private void butVerkettung_Click(object sender, EventArgs e)
        {
            string OrdinaryString = "";
            long st = stw.ElapsedTicks;
            for (int i = 0; i < 10000; i++)
            {
                OrdinaryString += "zeichenkette \r\n";
            }
            long time = stw.ElapsedTicks - st;

            textBox1.Text = OrdinaryString;
            labTime.Text = "Zeit=" + (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3") + " msec";

        }

        private void butVerkettungSB_Click(object sender, EventArgs e)
        {
            StringBuilder BetterString = new StringBuilder("");
            long st = stw.ElapsedTicks;
            for (int i = 0; i < 10000; i++)
            {
                BetterString.Append("zeichenkette \r\n");
            }
            long time = stw.ElapsedTicks - st;

            textBox1.Text = BetterString.ToString();
            labTime.Text = "Zeit=" + (time / (double)Stopwatch.Frequency * 1000.0).ToString("f3") + " msec";

        }

        private void butDouble_Click(object sender, EventArgs e)
        {
            string a = textBox1.Text;
            textBox1.Text = a + a;
        }

        // Fazit: replace bei string ist sogar schneller. Bei meinem adaptiveControl sind 48000 doppelte Leerz.
        // dann geht bei StringBuilder suchen (indexOf) und Substring nicht. meine Ansicht: Vergiss StringBuilder
        // es sei denn Verkettungen sind nötig, da ist Append schneller. 
        // Netter Infoartikel dazu: http://csharp-tricks.blogspot.de/2010/09/string-vs-stringbuilder.html
    }
}
